<?php

/**
 * Front-end of Miniblog_XH.
 *
 * @category  CMSimple_XH
 * @author    svasti <svasti@svasti.de>
 * @copyright 2014 svasti <http://svasti.de>
 * @version   0.2
 */

/*
 * Prevent direct access.
 */
if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

function mblogpages($pagenr='')
{
    global $s, $cl, $l, $cf;

    $o = '';
    $ta = array();
    $pagenr = $pagenr? $pagenr:$s;
    $tl = $l[$pagenr] + 1 + $cf['menu']['levelcatch'];
    for ($i = $pagenr + 1; $i < $cl; $i++) {
        if ($l[$i] <= $l[$pagenr]) {
            break;
        }
        if ($l[$i] <= $tl) {
                $ta[] = $i;
        }
        if ($l[$i] < $tl) {
            $tl = $l[$i];
        }
    }
    return $ta;
}



function mblogdata($mblog,$page,$cat='',$catpagenr='')
{
    global $plugin_cf, $h, $c, $pd_router;

    $page_data     = $pd_router->find_page($page);

    if(isset($page_data['expires']) && $page_data['expires']) {
        if(strtotime($page_data['expires'])<time()) return $mblog;
    }
    if(isset($page_data['publication_date']) && $page_data['publication_date']) {
        if(strtotime($page_data['publication_date'])>time()) {
            return $mblog;
        } else $mblog['time'][] = $date = strtotime($page_data['publication_date']);
    } else     $mblog['time'][] = $date = $page_data['last_edit'];
    $mblog['archive'][]     = $plugin_cf['miniblog']['archive_archiving_date']
                            && $date < strtotime($plugin_cf['miniblog']['archive_archiving_date'])
                            ? true
                            : false;
    $mblog['cat'][]    = $cat;
    if($catpagenr && $x = strpos($c[$catpagenr],'<img')) {
        $temp = substr($c[$catpagenr], $x);
        $mblog['img'][] = substr($temp, 0, strpos($temp,'>')+1);
    } else $mblog['img'][] = '';

    $mblog['pagenr'][] = $page;
    $mblog['title'][]  = $page_data['show_heading'] && $page_data['heading']
        ? $page_data['heading']
        : $h[$page];


    if($plugin_cf['miniblog']['keyword_show_keyword']) {
        if(isset($page_data['keywords']) && $page_data['keywords']) {
            $mblog['keyword'][] = $page_data['keywords'];
        } elseif($plugin_cf['miniblog']['keyword_2nd_source']) {
            preg_match ('!'.$plugin_cf['miniblog']['keyword_2nd_source'].'.*>(.*)</!iU',$c[$page],$matches);
            $mblog['keyword'][] = isset($matches[1])? $matches[1]:'';
        } else $mblog['keyword'][] = '';
    }
    $mblog['teaser'][] = isset($page_data['description']) && $page_data['description']
        ? $page_data['description']
        : mb_substr(strip_tags(substr($c[$page],(strpos($c[$page],$plugin_cf['miniblog']['teaser_2nd_source'])),550)),0,$plugin_cf['miniblog']['teaser_generated_length']);

    return $mblog;
}

function miniblog()
{
    global $plugin_cf, $plugin_tx, $h, $c, $pd_router, $bjs;

    $o = '';
    $mblog = array();

    // make long text vars shorter
    $cf = $plugin_cf['miniblog'];

    // create sortable arrays
    foreach (mblogpages() as $value) {

        if(!mblogpages($value)) {
            $mblog =  mblogdata($mblog,$value);
        } else {
            foreach (mblogpages($value) as $subvalue) {
                $mblog =  mblogdata($mblog,$subvalue,$h[$value],$value);
            }
        }
    }


    // sort newest first
    if($plugin_cf['miniblog']['date_order_blogs']) {
        array_multisort($mblog['time'], SORT_NUMERIC, SORT_DESC,
                $mblog['cat'],$mblog['keyword'],$mblog['pagenr'],$mblog['title'],$mblog['teaser'],$mblog['archive'],$mblog['img']);
    }

    // start Html
    $o .= "\n\n<!-- M I N I B L O G    S T A R T -->\n" . '<div class="mblog">' . "\n";

    // create buttons to make different categories visible
    if($cf['category_select_button'] || $cf['archive_select_button']) {
        $o .= '<div class="mblog_selectors">';

        $o .= $cf['archive_select_button']
            ? '<button class="mblog_off" id="mblog_archive" type="submit" onclick="toggle_visibility(\'mblog_archive\');">'
            . $plugin_tx['miniblog']['archive']
            . '</button>'
            : '';

        if($cf['category_select_button']) {
            foreach (mblogpages() as $cat) {
                if(mblogpages($cat)) {
                    $o .= '<button class="mblog_off" id="'
                       . uenc($h[$cat])
                       . '" type="submit" onclick="toggle_visibility(\''
                       . uenc($h[$cat])
                       . '\');">'
                       . $h[$cat]
                       . '</button>';
                }
            }
        }

        $bjs = '<script type="text/javascript">

    // <![CDATA[
    function getElementsByClassName(node,classname) {
        if (node.getElementsByClassName) { // use native implementation if available
            return node.getElementsByClassName(classname);
        } else {
            return (function getElementsByClass(node, classname) {
                var a = [];
                var re = new RegExp(\'(^| )\'+classname+\'( |$)\');
                var els = node.getElementsByTagName("*");
                for(var i=0,j=els.length; i<j; i++)
                    if(re.test(els[i].className))a.push(els[i]);
                return a;
             })(node, classname);
        }
    }

    function toggle_visibility(x) {
        if(document.getElementById(x).className == "mblog_off") {

            var allbuttons = getElementsByClassName(document, "mblog_on"),
                n = allbuttons.length;
            for (var i = 0; i < n; i++) {
                allbuttons[i].className = "mblog_off";
            }
            document.getElementById(x).className = "mblog_on";

            var allitems = getElementsByClassName(document, "mblog_item"),
                n = allitems.length;
            for (var i = 0; i < n; i++) {
                allitems[i].style.display = "none";
            }
            var elements = getElementsByClassName(document, x),
                n = elements.length;
            for (var i = 0; i < n; i++) {
                elements[i].style.display = "block";
            }
        } else {
            document.getElementById(x).className = "mblog_off";

            var allitems = getElementsByClassName(document, "mblog_item"),
                n = allitems.length;
            for (var i = 0; i < n; i++) {
                allitems[i].style.display = "block";
            }
            var elements = getElementsByClassName(document, "mblog_archive"),
                n = elements.length;
            for (var i = 0; i < n; i++) {
                elements[i].style.display = "none";
            }
        }
    }
    // ]]>
                  </script>';
        $o .= '</div>';
    }


    // create the items of the blog menu
    foreach ($mblog['time'] as $k=>$value) {

        $o .= $mblog['archive'][$k]
            ? '<div class="mblog_item mblog_archive">' . "\n"
            : '<div class="mblog_item '.uenc($mblog['cat'][$k]).'">' . "\n";

        $o .= $cf['category_show_category']
            ? '<p class="mblog_cat">'.$mblog['cat'][$k].'</p>'
            : '';

        $o .= '<p>';
        $o .= $cf['date_show_date']
            ? '<span class="mblog_time">'.date($cf['date_format'],$mblog['time'][$k]).'</span>'
            : '';
        $o .= $cf['keyword_show_keyword']
            ? ' <span class="mblog_keyword">'.$mblog['keyword'][$k].'</span>'
            : '';
        $o .= '</p>';
        $o .= '<'.$cf['title_style'].' class="mblog_title">'
           . a($mblog['pagenr'][$k],'')
           . $mblog['title'][$k]
           . '</a>'
           . '</'.$cf['title_style'].'>'
           . "\n\n";

        $o .= $mblog['archive'][$k]
            ? ''
            : '<p class="mblog_teaser">' . $mblog['img'][$k] . $mblog['teaser'][$k] . ' <span>'
            . a($mblog['pagenr'][$k],'') . $plugin_tx['miniblog']['more'] .'</a></span></p>';
        $o .= "\n</div>\n\n";
    }

    $o .= "\n" . '</div>'."\n\n<!-- M I N I B L O G    E N D -->\n\n\n";

    return $o;
}
?>